package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.DateUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.Qualification;
import de.humance.eco.profile.model.QualificationModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Qualification service. Represents a row in the &quot;Profile_Qualification&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationImpl
 * @see de.humance.eco.profile.model.Qualification
 * @see de.humance.eco.profile.model.QualificationModel
 * @generated
 */
public class QualificationModelImpl extends BaseModelImpl<Qualification>
    implements QualificationModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification model instance should use the {@link de.humance.eco.profile.model.Qualification} interface instead.
     */
    public static final String TABLE_NAME = "Profile_Qualification";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationId", Types.BIGINT },
            { "creatorId", Types.BIGINT },
            { "creatorName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifierId", Types.BIGINT },
            { "modifierName", Types.VARCHAR },
            { "modifiedDate", Types.TIMESTAMP },
            { "ownerId", Types.BIGINT },
            { "typeId", Types.BIGINT },
            { "name", Types.VARCHAR },
            { "certNumber", Types.VARCHAR },
            { "deliveryDate", Types.TIMESTAMP },
            { "expirationDate", Types.TIMESTAMP },
            { "issuingCountry", Types.VARCHAR },
            { "issuingInstitution", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_Qualification (qualificationId LONG not null primary key,creatorId LONG,creatorName VARCHAR(255) null,createDate DATE null,modifierId LONG,modifierName VARCHAR(255) null,modifiedDate DATE null,ownerId LONG,typeId LONG,name VARCHAR(500) null,certNumber VARCHAR(255) null,deliveryDate DATE null,expirationDate DATE null,issuingCountry VARCHAR(75) null,issuingInstitution VARCHAR(500) null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_Qualification";
    public static final String ORDER_BY_JPQL = " ORDER BY qualification.ownerId ASC, qualification.typeId ASC, qualification.deliveryDate ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_Qualification.ownerId ASC, Profile_Qualification.typeId ASC, Profile_Qualification.deliveryDate ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.Qualification"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.Qualification"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.Qualification"),
            true);
    public static long OWNERID_COLUMN_BITMASK = 1L;
    public static long TYPEID_COLUMN_BITMASK = 2L;
    public static long DELIVERYDATE_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.Qualification"));
    private static ClassLoader _classLoader = Qualification.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            Qualification.class
        };
    private long _qualificationId;
    private long _creatorId;
    private String _creatorName;
    private Date _createDate;
    private long _modifierId;
    private String _modifierName;
    private Date _modifiedDate;
    private long _ownerId;
    private long _originalOwnerId;
    private boolean _setOriginalOwnerId;
    private long _typeId;
    private long _originalTypeId;
    private boolean _setOriginalTypeId;
    private String _name;
    private String _certNumber;
    private Date _deliveryDate;
    private Date _expirationDate;
    private String _issuingCountry;
    private String _issuingInstitution;
    private long _columnBitmask;
    private Qualification _escapedModel;

    public QualificationModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Qualification.class;
    }

    @Override
    public String getModelClassName() {
        return Qualification.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationId", getQualificationId());
        attributes.put("creatorId", getCreatorId());
        attributes.put("creatorName", getCreatorName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifierId", getModifierId());
        attributes.put("modifierName", getModifierName());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("ownerId", getOwnerId());
        attributes.put("typeId", getTypeId());
        attributes.put("name", getName());
        attributes.put("certNumber", getCertNumber());
        attributes.put("deliveryDate", getDeliveryDate());
        attributes.put("expirationDate", getExpirationDate());
        attributes.put("issuingCountry", getIssuingCountry());
        attributes.put("issuingInstitution", getIssuingInstitution());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationId = (Long) attributes.get("qualificationId");

        if (qualificationId != null) {
            setQualificationId(qualificationId);
        }

        Long creatorId = (Long) attributes.get("creatorId");

        if (creatorId != null) {
            setCreatorId(creatorId);
        }

        String creatorName = (String) attributes.get("creatorName");

        if (creatorName != null) {
            setCreatorName(creatorName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Long modifierId = (Long) attributes.get("modifierId");

        if (modifierId != null) {
            setModifierId(modifierId);
        }

        String modifierName = (String) attributes.get("modifierName");

        if (modifierName != null) {
            setModifierName(modifierName);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        Long ownerId = (Long) attributes.get("ownerId");

        if (ownerId != null) {
            setOwnerId(ownerId);
        }

        Long typeId = (Long) attributes.get("typeId");

        if (typeId != null) {
            setTypeId(typeId);
        }

        String name = (String) attributes.get("name");

        if (name != null) {
            setName(name);
        }

        String certNumber = (String) attributes.get("certNumber");

        if (certNumber != null) {
            setCertNumber(certNumber);
        }

        Date deliveryDate = (Date) attributes.get("deliveryDate");

        if (deliveryDate != null) {
            setDeliveryDate(deliveryDate);
        }

        Date expirationDate = (Date) attributes.get("expirationDate");

        if (expirationDate != null) {
            setExpirationDate(expirationDate);
        }

        String issuingCountry = (String) attributes.get("issuingCountry");

        if (issuingCountry != null) {
            setIssuingCountry(issuingCountry);
        }

        String issuingInstitution = (String) attributes.get(
                "issuingInstitution");

        if (issuingInstitution != null) {
            setIssuingInstitution(issuingInstitution);
        }
    }

    @Override
    public long getQualificationId() {
        return _qualificationId;
    }

    @Override
    public void setQualificationId(long qualificationId) {
        _qualificationId = qualificationId;
    }

    @Override
    public long getCreatorId() {
        return _creatorId;
    }

    @Override
    public void setCreatorId(long creatorId) {
        _creatorId = creatorId;
    }

    @Override
    public String getCreatorName() {
        if (_creatorName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorName;
        }
    }

    @Override
    public void setCreatorName(String creatorName) {
        _creatorName = creatorName;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public long getModifierId() {
        return _modifierId;
    }

    @Override
    public void setModifierId(long modifierId) {
        _modifierId = modifierId;
    }

    @Override
    public String getModifierName() {
        if (_modifierName == null) {
            return StringPool.BLANK;
        } else {
            return _modifierName;
        }
    }

    @Override
    public void setModifierName(String modifierName) {
        _modifierName = modifierName;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public long getOwnerId() {
        return _ownerId;
    }

    @Override
    public void setOwnerId(long ownerId) {
        _columnBitmask = -1L;

        if (!_setOriginalOwnerId) {
            _setOriginalOwnerId = true;

            _originalOwnerId = _ownerId;
        }

        _ownerId = ownerId;
    }

    public long getOriginalOwnerId() {
        return _originalOwnerId;
    }

    @Override
    public long getTypeId() {
        return _typeId;
    }

    @Override
    public void setTypeId(long typeId) {
        _columnBitmask = -1L;

        if (!_setOriginalTypeId) {
            _setOriginalTypeId = true;

            _originalTypeId = _typeId;
        }

        _typeId = typeId;
    }

    public long getOriginalTypeId() {
        return _originalTypeId;
    }

    @Override
    public String getName() {
        if (_name == null) {
            return StringPool.BLANK;
        } else {
            return _name;
        }
    }

    @Override
    public void setName(String name) {
        _name = name;
    }

    @Override
    public String getCertNumber() {
        if (_certNumber == null) {
            return StringPool.BLANK;
        } else {
            return _certNumber;
        }
    }

    @Override
    public void setCertNumber(String certNumber) {
        _certNumber = certNumber;
    }

    @Override
    public Date getDeliveryDate() {
        return _deliveryDate;
    }

    @Override
    public void setDeliveryDate(Date deliveryDate) {
        _columnBitmask = -1L;

        _deliveryDate = deliveryDate;
    }

    @Override
    public Date getExpirationDate() {
        return _expirationDate;
    }

    @Override
    public void setExpirationDate(Date expirationDate) {
        _expirationDate = expirationDate;
    }

    @Override
    public String getIssuingCountry() {
        if (_issuingCountry == null) {
            return StringPool.BLANK;
        } else {
            return _issuingCountry;
        }
    }

    @Override
    public void setIssuingCountry(String issuingCountry) {
        _issuingCountry = issuingCountry;
    }

    @Override
    public String getIssuingInstitution() {
        if (_issuingInstitution == null) {
            return StringPool.BLANK;
        } else {
            return _issuingInstitution;
        }
    }

    @Override
    public void setIssuingInstitution(String issuingInstitution) {
        _issuingInstitution = issuingInstitution;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            Qualification.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Qualification toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Qualification) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationImpl qualificationImpl = new QualificationImpl();

        qualificationImpl.setQualificationId(getQualificationId());
        qualificationImpl.setCreatorId(getCreatorId());
        qualificationImpl.setCreatorName(getCreatorName());
        qualificationImpl.setCreateDate(getCreateDate());
        qualificationImpl.setModifierId(getModifierId());
        qualificationImpl.setModifierName(getModifierName());
        qualificationImpl.setModifiedDate(getModifiedDate());
        qualificationImpl.setOwnerId(getOwnerId());
        qualificationImpl.setTypeId(getTypeId());
        qualificationImpl.setName(getName());
        qualificationImpl.setCertNumber(getCertNumber());
        qualificationImpl.setDeliveryDate(getDeliveryDate());
        qualificationImpl.setExpirationDate(getExpirationDate());
        qualificationImpl.setIssuingCountry(getIssuingCountry());
        qualificationImpl.setIssuingInstitution(getIssuingInstitution());

        qualificationImpl.resetOriginalValues();

        return qualificationImpl;
    }

    @Override
    public int compareTo(Qualification qualification) {
        int value = 0;

        if (getOwnerId() < qualification.getOwnerId()) {
            value = -1;
        } else if (getOwnerId() > qualification.getOwnerId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        if (getTypeId() < qualification.getTypeId()) {
            value = -1;
        } else if (getTypeId() > qualification.getTypeId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = DateUtil.compareTo(getDeliveryDate(),
                qualification.getDeliveryDate());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Qualification)) {
            return false;
        }

        Qualification qualification = (Qualification) obj;

        long primaryKey = qualification.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationModelImpl qualificationModelImpl = this;

        qualificationModelImpl._originalOwnerId = qualificationModelImpl._ownerId;

        qualificationModelImpl._setOriginalOwnerId = false;

        qualificationModelImpl._originalTypeId = qualificationModelImpl._typeId;

        qualificationModelImpl._setOriginalTypeId = false;

        qualificationModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Qualification> toCacheModel() {
        QualificationCacheModel qualificationCacheModel = new QualificationCacheModel();

        qualificationCacheModel.qualificationId = getQualificationId();

        qualificationCacheModel.creatorId = getCreatorId();

        qualificationCacheModel.creatorName = getCreatorName();

        String creatorName = qualificationCacheModel.creatorName;

        if ((creatorName != null) && (creatorName.length() == 0)) {
            qualificationCacheModel.creatorName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            qualificationCacheModel.createDate = createDate.getTime();
        } else {
            qualificationCacheModel.createDate = Long.MIN_VALUE;
        }

        qualificationCacheModel.modifierId = getModifierId();

        qualificationCacheModel.modifierName = getModifierName();

        String modifierName = qualificationCacheModel.modifierName;

        if ((modifierName != null) && (modifierName.length() == 0)) {
            qualificationCacheModel.modifierName = null;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            qualificationCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            qualificationCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        qualificationCacheModel.ownerId = getOwnerId();

        qualificationCacheModel.typeId = getTypeId();

        qualificationCacheModel.name = getName();

        String name = qualificationCacheModel.name;

        if ((name != null) && (name.length() == 0)) {
            qualificationCacheModel.name = null;
        }

        qualificationCacheModel.certNumber = getCertNumber();

        String certNumber = qualificationCacheModel.certNumber;

        if ((certNumber != null) && (certNumber.length() == 0)) {
            qualificationCacheModel.certNumber = null;
        }

        Date deliveryDate = getDeliveryDate();

        if (deliveryDate != null) {
            qualificationCacheModel.deliveryDate = deliveryDate.getTime();
        } else {
            qualificationCacheModel.deliveryDate = Long.MIN_VALUE;
        }

        Date expirationDate = getExpirationDate();

        if (expirationDate != null) {
            qualificationCacheModel.expirationDate = expirationDate.getTime();
        } else {
            qualificationCacheModel.expirationDate = Long.MIN_VALUE;
        }

        qualificationCacheModel.issuingCountry = getIssuingCountry();

        String issuingCountry = qualificationCacheModel.issuingCountry;

        if ((issuingCountry != null) && (issuingCountry.length() == 0)) {
            qualificationCacheModel.issuingCountry = null;
        }

        qualificationCacheModel.issuingInstitution = getIssuingInstitution();

        String issuingInstitution = qualificationCacheModel.issuingInstitution;

        if ((issuingInstitution != null) && (issuingInstitution.length() == 0)) {
            qualificationCacheModel.issuingInstitution = null;
        }

        return qualificationCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(31);

        sb.append("{qualificationId=");
        sb.append(getQualificationId());
        sb.append(", creatorId=");
        sb.append(getCreatorId());
        sb.append(", creatorName=");
        sb.append(getCreatorName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifierId=");
        sb.append(getModifierId());
        sb.append(", modifierName=");
        sb.append(getModifierName());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", ownerId=");
        sb.append(getOwnerId());
        sb.append(", typeId=");
        sb.append(getTypeId());
        sb.append(", name=");
        sb.append(getName());
        sb.append(", certNumber=");
        sb.append(getCertNumber());
        sb.append(", deliveryDate=");
        sb.append(getDeliveryDate());
        sb.append(", expirationDate=");
        sb.append(getExpirationDate());
        sb.append(", issuingCountry=");
        sb.append(getIssuingCountry());
        sb.append(", issuingInstitution=");
        sb.append(getIssuingInstitution());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(49);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.Qualification");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationId</column-name><column-value><![CDATA[");
        sb.append(getQualificationId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorId</column-name><column-value><![CDATA[");
        sb.append(getCreatorId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorName</column-name><column-value><![CDATA[");
        sb.append(getCreatorName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierId</column-name><column-value><![CDATA[");
        sb.append(getModifierId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierName</column-name><column-value><![CDATA[");
        sb.append(getModifierName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>ownerId</column-name><column-value><![CDATA[");
        sb.append(getOwnerId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>typeId</column-name><column-value><![CDATA[");
        sb.append(getTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>name</column-name><column-value><![CDATA[");
        sb.append(getName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>certNumber</column-name><column-value><![CDATA[");
        sb.append(getCertNumber());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>deliveryDate</column-name><column-value><![CDATA[");
        sb.append(getDeliveryDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>expirationDate</column-name><column-value><![CDATA[");
        sb.append(getExpirationDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>issuingCountry</column-name><column-value><![CDATA[");
        sb.append(getIssuingCountry());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>issuingInstitution</column-name><column-value><![CDATA[");
        sb.append(getIssuingInstitution());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
